import gtk

def chooser(dialog_name, topwin, mode=gtk.FILE_CHOOSER_ACTION_OPEN,
            file=None, folder=None, type=None):
    fcdialog = gtk.FileChooserDialog(dialog_name, topwin, mode,
                                     (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                     gtk.STOCK_OPEN, gtk.RESPONSE_ACCEPT))
    if file:
        # file normally has the form of <type>:/<path>/<image file>
        if file.startswith("file:"):
            filename = file[5:]
        elif file.startswith("phy:"):
            filename = file[4:]
        elif file.startswith("iscsi:"):
            filename = file[6:]
        elif file.startswith("tap:aio:"):
            filename = file[8:]
        elif file.startswith("tap:qcow:"):
            filename = file[9:]
        elif file.startswith("tap:vmdk:"):
            filename = file[9:]
        elif file.startswith("npiv:"):
            filename = file[5:]
        elif file.startswith("nbd:"):
            filename = file[4:]
        else:
            filename = file
        file = filename
        fcdialog.set_filename(file)
    if folder:
        fcdialog.set_current_folder(folder)
    if mode == gtk.FILE_CHOOSER_ACTION_SAVE:
        fcdialog.set_do_overwrite_confirmation(True)
    if type != None:
        f = gtk.FileFilter()
        f.add_pattern("*." + type)
        fcdialog.set_filter(f)
    response = fcdialog.run()
    fcdialog.hide()
    if response == gtk.RESPONSE_ACCEPT:
        filename = fcdialog.get_filename()
        folder = fcdialog.get_current_folder()
        fcdialog.destroy()
        return (filename, folder)
    else:
        fcdialog.destroy()
        return (None, None)

